// SharedMem.cpp : Defines the entry point for the console application.
// Mutex Reference: http://msdn.microsoft.com/en-us/library/windows/desktop/ms686927(v=vs.85).aspx
// Large Page Shared Named Memory Reference: http://msdn.microsoft.com/en-us/library/windows/desktop/aa366543(v=vs.85).aspx
// Small Page Shared Named Memory Reference: http://msdn.microsoft.com/en-us/library/windows/desktop/aa366551(v=vs.85).aspx
// Launch SharedMemClient.cpp first because it is created the Shared Memory and then launch SharedMem.cpp

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <tchar.h>
#include "privilege.h"
#include "SharedMem.h"

#define CREATE_MAP
int _tmain()
{
	TCHAR szMsg[]=TEXT(" Message from first process.");
	TCHAR szName[]=TEXT(FILE_MAP_NAME);
	TCHAR mutexName[]=TEXT(MUTEX_NAME) ;
	//TCHAR szName[]=TEXT("Global\\MyFileMappingObject");
	//TCHAR mutexName[]=TEXT("Global\\MyFileMutex") ;

   HANDLE hMapFile;
   LPCTSTR pStartOfBuf ;
   int	*pCurrBufInt ;
   char *pCurrBufChar ;
   HANDLE ghMutex; 
   DWORD dwWaitResult; 
   int wrPtr, rdPtr, numElements, i ;

   // Create Mutex
	ghMutex = CreateMutex( 
        NULL,              // default security attributes
        FALSE,             // initially not owned
        mutexName);             // unnamed mutex

    if (ghMutex == NULL) 
    {
		_tprintf(TEXT("CreateMutex error: %d\n"),GetLastError());
		return 1;
    }
	long largePageMin = GetLargePageMinimum();
	long smSize = (ALL_BUFS_SIZE/largePageMin + 1)*largePageMin ;
	Privilege(TEXT("SeLockMemoryPrivilege"), TRUE);


#ifdef CREATE_MAP
	 // Create Shared Memory
   hMapFile = CreateFileMapping(
                 INVALID_HANDLE_VALUE,    // use paging file
                 NULL,                    // default security
                 PAGE_READWRITE | SEC_COMMIT | SEC_LARGE_PAGES,          // read/write access and large pages
                 0, // maximum object size (high-order DWORD)
                 smSize, // maximum object size (low-order DWORD)
                 szName);                 // name of mapping object
   printf("Shared Memory Created\n") ;

#else
	 hMapFile = OpenFileMapping(
                   FILE_MAP_ALL_ACCESS,   // read/write access
                   FALSE,                 // do not inherit the name
                   szName);               // name of mapping object
   printf("Connected to Shared Memory\n") ;
#endif
   if (hMapFile == NULL)
   {
      _tprintf(TEXT("Could not create file mapping object (%d).\n"),
             GetLastError());
      return 1;
   }


   pStartOfBuf = (LPTSTR) MapViewOfFile(hMapFile,   // handle to map object
                        FILE_MAP_ALL_ACCESS, // read/write permission
                        0,
                        0,
                        smSize);

   if (pStartOfBuf == NULL)
   {
      _tprintf(TEXT("Could not map view of file (%d).\n"),
             GetLastError());

       CloseHandle(hMapFile);

      return 1;
   }

	// Initialize rdPtr and wrPtr
   dwWaitResult = WaitForSingleObject( 
        ghMutex,    // handle to mutex
        INFINITE);  // no time-out interval


	for (i=0;i<smSize;i++)
	{
		*((char *)pStartOfBuf + i) = 0 ;
	}
	MM_VALUE(pStartOfBuf,ELEMENT_SIZE) = BUF_SIZE ;
	MM_VALUE(pStartOfBuf,MAX_ELEMENTS) = NUM_BUFS ;

   if (!ReleaseMutex(ghMutex))
   {
      _tprintf(TEXT("ReleaseMutex error: %d\n"),
             GetLastError());
      return 1;
   }
   printf("hMapFile %x\n",hMapFile) ;
   printf("ghMutex %x\n",ghMutex) ;
   printf("pStartOfBuf %x\n",pStartOfBuf) ;

   printf("Press Enter to start sending messages\n") ;
   _getch();

   // Write messages to Shared Memory
   i = 0 ;
   while (i < NUM_BUFS)
   {
        dwWaitResult = WaitForSingleObject( 
            ghMutex,    // handle to mutex
            INFINITE);  // no time-out interval
		rdPtr = MM_VALUE(pStartOfBuf,RD_PTR) ;
		wrPtr = MM_VALUE(pStartOfBuf,WR_PTR) ;
		numElements = MM_VALUE(pStartOfBuf,NUM_ELEMENTS) ;
		if ((wrPtr != rdPtr) || (numElements == 0))
		{
			szMsg[0] = wrPtr + 0x30 ; // Ascii for buf number
			pCurrBufChar = (char *)pStartOfBuf +  HEADER_SIZE + wrPtr*BUF_SIZE ;
			CopyMemory((PVOID)pCurrBufChar, szMsg, (_tcslen(szMsg) * sizeof(TCHAR)));
			MM_VALUE(pStartOfBuf,WR_PTR) = (wrPtr + 1) % NUM_BUFS ;
			MM_VALUE(pStartOfBuf,NUM_ELEMENTS) = numElements + 1 ;
			i++ ;
		    printf("Sent %d message\n",i) ;
		}
		if (!ReleaseMutex(ghMutex))
		{
			_tprintf(TEXT("ReleaseMutex error: %d\n"),GetLastError());
			return 1;
		}
		Sleep(1000) ;
   }
   printf("Press Enter to destroy shared mem and mutex\n") ;
   _getch();

   Privilege(TEXT("SeLockMemoryPrivilege"), FALSE);

   CloseHandle(ghMutex);
	UnmapViewOfFile(pStartOfBuf);

   CloseHandle(hMapFile);

   return 0;
}
